using System;
using System.Text;
using System.IO;

namespace ConsoleApplication1
{
    class Program
    {
        static void Main(string[] args)
        {
            string s = File.ReadAllText("input.txt");
            string[] w = s.Split(new char[] {' ','\n','\r'}, StringSplitOptions.RemoveEmptyEntries);
            int n = Int32.Parse(w[0]);
            int[] high = new int[n + 1];
            int[] low  = new int[n + 1];
            low[1] = high[1] = 1;
            for (int i = 2; i < n + 1; i++)
            {
                low[i] = high[i] = 1;
                for (int j = 1; j < i; j++)
                {
                    if (String.Compare(w[j], w[i]) < 0 && high[i] < high[j] + 1) high[i] = high[j] + 1;
                    if (String.Compare(w[j], w[i]) > 0 && low[i] < low[j] + 1) low[i] = low[j] + 1;
                }
            }
            int max = 1;
            for (int i = 1; i < n +1; i++)
                max= Math.Max(max,Math.Max(low[i],high[i])); 
            File.WriteAllText("output.txt", String.Format("{0}", max));
        }
    }
}
