

#include<fstream>
#include<iomanip>
#include<iostream>
#include<math.h>

using namespace std;

double d(double x1, int y1, int z1, int x2, int y2, int z2)
{
  return sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2)+(z1-z2)*(z1-z2));
}

double min(double d1, double d2)
{
  if (d1<d2) return d1; else return d2;
}

double min(double d1, double d2, double d3, double d4, double d5)
{
  return min (min(d1,d2),min(d3,min(d4,d5)));
}


int main()
{

  ifstream f("input.txt");
  ofstream g("output.txt");

  int w,l,h,x1,x2,y1,y2,z1,z2;
  f>>w>>l>>h>>x1>>y1>>z1>>x2>>y2>>z2;
  double m=w+l+h;

  if (x1==0)
  {
    if (z2==h)  m=min(m,d(x1,y1,z1,0,y2,z2+x2));
    if (z2==0) m=min(m,d(x1,y1,z1,0,y2,z2-x2));
    if (y2==0) m=min(m,d(x1,y1,z1,0, -x2,z2));
    if (y2==l) m=min(m,d(x1,y1,z1,0,l+x2,z2));
    if (x2==w) m=min(m,
                   d(x1,y1,z1,0,l+w+(l-y2),z2),
             d(x1,y1,z1,0,y2,h+w+(h-z2)),
             d(x1,y1,z1,0,-w-y2,z2),
             d(x1,y1,z1,0,y2,-w-z2));
  }
  if (x1==w)
  {
    if (z2==h) m=min(m,d(x1,y1,z1,w,y2,z2+(w-x2)));
    if (z2==0) m=min(m,d(x1,y1,z1,w,y2,z2-(w-x2)));
    if (y2==0) m=min(m,d(x1,y1,z1,w, -(w-x2),z2));
    if (y2==l) m=min(m,d(x1,y1,z1,w,l+(w-x2),z2));
    if (x2==0) m=min(m,
                   d(x1,y1,z1,w,y2,h+w+(h-z2)),
             d(x1,y1,z1,w,y2,-w-z2),
             d(x1,y1,z1,w,l+w+(l-y2),z2),
             d(x1,y1,z1,w,-w-y2,z2));

  }
  if (y1==0)
  {
    if (z2==h)  m=min(m,d(x1,y1,z1,x2,0,z2+y2));
    if (z2==0) m=min(m,d(x1,y1,z1,x2,0,z2-y2));
    if (x2==0) m=min(m,d(x1,y1,z1,-y2,0,z2));
    if (x2==w) m=min(m,d(x1,y1,z1,w+y2,0,z2));
    if (y2==l) m=min(m,
                   d(x1,y1,z1,x2,0,h+l+(h-z2)),
             d(x1,y1,z1,x2,0,-l-z2),
             d(x1,y1,z1,w+l+(w-x2),0,z2),
             d(x1,y1,z1,-l-x2,0,z2));
  }
  if (y1==l)
  {
    if (z2==h)  m=min(m,d(x1,y1,z1,x2,l,z2+(l-y2)));
    if (z2==0) m=min(m,d(x1,y1,z1,x2,l,-(l-y2)));
    if (x2==0) m=min(m,d(x1,y1,z1,-(l-y2),l,z2));
    if (x2==w) m=min(m,d(x1,y1,z1,w+(l-y2),l,z2));
    if (y2==0) m=min(m,
                   d(x1,y1,z1,x2,l,h+l+(h-z2)),
             d(x1,y1,z1,x2,l,-l-z2),
             d(x1,y1,z1,w+l+(w-x2),l,z2),
             d(x1,y1,z1,-l-x2,l,z2));
  
  }
  if (z1==0)
  {
    if (x2==w)  m=min(m,d(x1,y1,z1,w+z2,y2,0));
    if (x2==0) m=min(m,d(x1,y1,z1,-z2,y2,0));
    if (y2==0) m=min(m,d(x1,y1,z1,x2,-z2,0));
    if (y2==l) m=min(m,d(x1,y1,z1,x2,l+z2,0));
    if (z2==h) m=min(m,
                   d(x1,y1,z1,x2,l+h+(l-y2),0),
             d(x1,y1,z1,x2,-h-y2,0),
             d(x1,y1,z1,w+h+(w-x2),y2,0),
             d(x1,y1,z1,-h-x2,y2,0));

  }
  if (z1==h)
  {
    if (x2==w)  m=min(m,d(x1,y1,z1,w+(h-z2),y2,h));
    if (x2==0) m=min(m,d(x1,y1,z1,-(h-z2),y2,h));
    if (y2==0) m=min(m,d(x1,y1,z1,x2,-(h-z2),h));
    if (y2==l) m=min(m,d(x1,y1,z1,x2,l+(h-z2),h));
    if (z2==0) m=min(m,
                   d(x1,y1,z1,x2,l+h+(l-y2),h),
             d(x1,y1,z1,x2,-h-y2,h),
             d(x1,y1,z1,w+h+(w-x2),y2,h),
             d(x1,y1,z1,-h-x2,y2,h));
  }

  
  g<<fixed<<setprecision(6)<<m;

  f.close();
  g.close();
  return 0;
}

